import 'dart:convert';

import 'package:base_utils/network/http_utils.dart';
import 'package:base_utils/network/http_utils.dart' as httpUtils;
import 'package:base_utils/network/service.dart';
import 'package:base_utils/router/router.dart';
import 'package:base_utils/ui/res/strings.dart';

class UserService extends Service {
  UserService(String groupName) : super(groupName);

  Future<dynamic> login(httpUtils.DataRequest<dynamic> dataRequest,
      {bool isTestLogin = false}) async {
    final isDevelopment =
        Router.instance.currentFlavor == Router.FLAVOR_DEVELOPMENT;
    return await makeRequest(
      onSuccess: (data) {
        var rest = json.decode(data);
        if (isDevelopment) {
          rest = rest['user_info'];
        }
        if (rest != null &&
            (rest['access_token'] != null || rest['token'] != null)) {
          if (rest['token'] != null) rest['access_token'] = rest['token'];
          dataRequest?.onSuccess(rest);
        } else {
          dataRequest?.onFailure('FAIL!');
        }
      },
      onFailure: (e) {
        dataRequest?.onFailure(AssetsString.default_error_message);
      },
      method: Method.POST,
      host: isDevelopment ? Domain.API_URL : Domain.MAPI_URL,
      path: isDevelopment ? 'general/login/login/' : 'mob/user/login',
      header: isDevelopment
          ? null
          : {
              'Content-Type': 'application/x-www-form-urlencoded',
            },
      params: {
//        'username': 'tkm1@gmail.com',
////          'username': 'sendotester2@gmail.com',
//        'password': '123456',

        //account test

        'username':
            isTestLogin ? "testtest9@gmail.com" : Router.instance.userName,
        'password': isTestLogin ? "123456" : Router.instance.passWord,
      },
    );
  }

  @override
  void dispose() {}
}
